/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s): 
 *   Jan Varga <varga@utcru.sk> (Original Author)
 */

#ifndef nsDatabaseOutlinerView_h
#define nsDatabaseOutlinerView_h                                                  


#include "nsIOutlinerView.h"
#include "nsCOMPtr.h"
#include "nsIOutlinerBoxObject.h"
#include "nsIOutlinerSelection.h"

#include "nsIDatabaseOutlinerView.h"
#include "nsIDatabaseRowList.h"


class nsDatabaseOutlinerView : public nsIOutlinerView,
                                      nsIDatabaseOutlinerView,
                                      nsIDatabaseRowListObserver
{
  public:
    nsDatabaseOutlinerView(void);
    virtual ~nsDatabaseOutlinerView(void);

    NS_DECL_ISUPPORTS

    NS_DECL_NSIOUTLINERVIEW

    NS_DECL_NSIDATABASEOUTLINERVIEW

    NS_DECL_NSIDATABASEROWLISTOBSERVER

  private:
    nsCOMPtr<nsIOutlinerBoxObject>      mBoxObject;
    nsCOMPtr<nsIOutlinerSelection>      mSelection;
    nsCOMPtr<nsIDatabaseRowList>        mRowList;
};


#endif // nsDatabaseOutlinerView_h
