/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s): 
 *   Jan Varga <varga@utcru.sk> (Original Author)
 */

#ifndef nsDatabaseCID_h
#define nsDatabaseCID_h


#include "rdf.h"


#define NS_DATABASE_AUTO_COMPLETE_SESSION_CID \
{ 0x707cd0a3, 0x0e84, 0x48aa, { 0xba, 0x04, 0x0d, 0xae, 0x47, 0x7f, 0x6b, 0xd1 } }
#define NS_DATABASE_AUTO_COMPLETE_SESSION_CONTRACTID "@mozilla.org/autocompleteSession;1?type=database"

#define NS_DATABASE_DATA_SOURCE_CID \
{ 0x03fdc9a9, 0x4a0c, 0x4793, { 0x90, 0x83, 0x7f, 0x58, 0xbc, 0x23, 0xb3, 0x20 } }
#define NS_DATABASE_DATA_SOURCE_CONTRACTID NS_RDF_DATASOURCE_CONTRACTID_PREFIX "database"

#define NS_DATABASE_OUTLINER_VIEW_CID \
{ 0x7ae673b1, 0xeb07, 0x47f3, { 0xad, 0x1d, 0x00, 0x7f, 0xf4, 0x87, 0x46, 0x0a } }
#define NS_DATABASE_OUTLINER_VIEW_CONTRACTID "@mozilla.org/database/outlinerView;1"

#define NS_DATABASE_RESOURCE_CID \
{ 0xfa82281e, 0x778b, 0x4022, { 0x8e, 0x88, 0xd7, 0x9e, 0x90, 0x7a, 0x72, 0xea } }
#define NS_DATABASE_RESOURCE_CONTRACTID NS_RDF_RESOURCE_FACTORY_CONTRACTID_PREFIX "database"

#define NS_DATABASE_ROW_CID \
{ 0xbe231361, 0x8acf, 0x4e4f, { 0x97, 0x9d, 0xe8, 0x08, 0x50, 0x4c, 0x40, 0x9e } }
#define NS_DATABASE_ROW_CONTRACTID "@mozilla.org/database/row;1"

#define NS_DATABASE_ROW_LIST_CID \
{ 0x8e5188ab, 0x093a, 0x403d, { 0x99, 0x89, 0x48, 0xcb, 0x85, 0xd6, 0x32, 0xed } }
#define NS_DATABASE_ROW_LIST_CONTRACTID "@mozilla.org/database/rowList;1"

#ifdef MOZ_ENABLE_PGSQL
#define NS_DATABASE_CONNECTION_PGSQL_CID \
{ 0x0bba2a84, 0x572a, 0x447f, { 0x97, 0x11, 0x69, 0x9c, 0xdc, 0x3f, 0x64, 0xe5 } }
#define NS_DATABASE_CONNECTION_PGSQL_CONTRACTID "@mozilla.org/database/connection;1?type=pgsql"
#endif

#ifdef MOZ_ENABLE_MYSQL
#define NS_DATABASE_CONNECTION_MYSQL_CID \
{ 0xd1dd7555, 0x5368, 0x4125, { 0xa2, 0x2b, 0x71, 0x0b, 0xcd, 0x21, 0x5b, 0xc3 } }
#define NS_DATABASE_CONNECTION_MYSQL_CONTRACTID "@mozilla.org/database/connection;1?type=mysql"
#endif


#endif // nsDatabaseCID_h
