/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Netscape Communications
 * Corporation.  Portions created by Netscape are
 * Copyright (C) 2000 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s): 
 *   Jan Varga <varga@utcru.sk> (Original Author)
 */

var connection;

var databaseListener = {
  onResult: function(connection, context, rowList) {
    document.getElementById("asyncStateName").value = rowList.getRow(0).getValue(0);
  },
  
  onError: function(connection, context, errorCode, errorMessage) {
    alert(errorMessage);
  }
};

var autoCompleteProvider = {
  getSearchResult: function(searchKey) {
    dump("In getSearchResult\n");
    var query = "select trim(name) from states where name like '" + searchKey + "%'";
    return connection.exec(query);
  }
};


function connect() {
  dump("In connect\n");
  var databaseType = document.getElementById("databaseType").value;
  connection = Components.classes["@mozilla.org/database/connection;1?type=" + databaseType].createInstance();
  connection = connection.QueryInterface(Components.interfaces.nsIDatabaseConnection);
  connection.init(window);
  
  var hostName = document.getElementById("hostName").value;
  var port = document.getElementById("port").value;
  var databaseName = document.getElementById("databaseName").value;
  var username = document.getElementById("username").value;
  var password = document.getElementById("password").value;
  
  connection.connect(hostName, port, databaseName, username, password);
  if (connection.statusCode != connection.ERR_OK)
    alert(connection.statusMessage);
}

function disconnect() {
  dump('In disconnect\n');
  if (connection) {
    connection.disconnect();
    connection = null;
  }
}

function reconnect() {
  dump('In reconnect\n');
  disconnect();
  connect();
}

function initAutoComplete() {
  var autoCompleteSession = document.getElementById("autoStateName").getSessionByName("database");
  var databaseAutoCompleteSession = autoCompleteSession.QueryInterface(Components.interfaces.nsIDatabaseAutoCompleteSession);
  databaseAutoCompleteSession.provider = autoCompleteProvider;
}

function initDataSource() {
  var query = "select code, trim(name) from states";
  var rowList = connection.exec(query);
  rowList.setColumnName(0, "stateCode");
  rowList.setColumnName(1, "stateName");

  var databaseDataSource = Components.classes["@mozilla.org/rdf/datasource;1?name=database"].createInstance();
  databaseDataSource = databaseDataSource.QueryInterface(Components.interfaces.nsIDatabaseDataSource);
  databaseDataSource.rowList = rowList;

  dataSource = databaseDataSource.QueryInterface(Components.interfaces.nsIRDFDataSource);
  var statesMenulist = document.getElementById("statesMenulist");
  statesMenulist.database.AddDataSource(dataSource);
  statesMenulist.setAttribute("ref", "database://");
  
  statesMenulist.selectedIndex = 0;
}

function initOutliner() {
  var query = "select code, trim(name) from states";
  var rowList = connection.exec(query);
  rowList.setColumnName(0, "stateCodeCol");
  rowList.setColumnName(1, "stateNameCol");

  var databaseOutlinerView = Components.classes["@mozilla.org/database/outlinerView;1"].createInstance();
  outlinerDatabaseView = databaseOutlinerView.QueryInterface(Components.interfaces.nsIDatabaseOutlinerView);
  outlinerDatabaseView.rowList = rowList;

  var outlinerView = databaseOutlinerView.QueryInterface(Components.interfaces.nsIOutlinerView);
  var statesOutliner = document.getElementById("statesOutliner");
  statesOutliner.outlinerBoxObject.view = outlinerView;
}

function init() {
  connect();
  initAutoComplete();
  initDataSource();
  initOutliner();
}

function shutdown() {
  var statesOutliner = document.getElementById("statesOutliner");
  var outlinerView = statesOutliner.outlinerBoxObject.view;
  var outlinerDatabaseView = outlinerView.QueryInterface(Components.interfaces.nsIDatabaseOutlinerView);
  outlinerDatabaseView.rowList = null;
}

function syncFindState() {
  var code = document.getElementById("syncStateCode").value
  var query = "select trim(name) from states where code = '" + code + "'";
  var result = connection.exec(query);
  if (!result)
    alert(connection.errorMessage);
  else
    document.getElementById("syncStateName").value = result.getRow(0).getValue(0);
}

function asyncFindState() {
  var code = document.getElementById("asyncStateCode").value
  var query = "select trim(name) from states where code = '" + code + "'";
  connection.asyncExec(query, databaseListener, null);
}

function changeDatabaseType() {
  var databaseType = document.getElementById("databaseType").value;
  var port = document.getElementById("port");
  if (databaseType == "pgsql")
    port.value = 5432;
  else if (databaseType == "mysql")
    port.value = 3306;
}
